hdu 2680(最短路)

Choose the best route

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 12442    Accepted Submission(s): 4046


Problem Description
One day , Kiki wants to visit one of her friends. As she is liable to carsickness , she wants to arrive at her friend’s home as soon as possible . Now give you a map of the city’s traffic route, and the stations which are near Kiki’s home so that she can take. You may suppose Kiki can change the bus at any station. Please find out the least time Kiki needs to spend. To make it easy, if the city have n bus stations ,the stations will been expressed as an integer 1,2,3…n.
 
Input
There are several test cases.
Each case begins with three integers n, m and s,(n<1000,m<20000,1=<s<=n) n stands for the number of bus stations in this city and m stands for the number of directed ways between bus stations .(Maybe there are several ways between two bus stations .) s stands for the bus station that near Kiki’s friend’s home.
Then follow m lines ,each line contains three integers p , q , t (0<t<=1000). means from station p to station q there is a way and it will costs t minutes .
Then a line with an integer w(0<w<n), means the number of stations Kiki can take at the beginning. Then follows w integers stands for these stations.
 
Output
The output contains one line for each data set : the least time Kiki needs to spend ,if it’s impossible to find such a route ,just output “-1”.
 
Sample Input
5 8 5 1 2 2 1 5 3 1 3 4 2 4 7 2 5 6 2 3 5 3 5 1 4 5 1 2 2 3 4 3 4 1 2 3 1 3 4 2 3 2 1 1
 
Sample Output
1 -1
题意:给出n个点,m条单向边,然后给出一个终点,然后给出t个车站,求这些车站到终点耗费的时间最短是多少,如果不可达,输出-1.
题解:如果直接从车站去找是会超时的,所以我们把所有的边反向之后再从终点开始找,这样的话找一次就ok,还有就是这题要判重.
#include <stdio.h>
#include <algorithm>
#include <string.h>
#include <math.h>
#include <queue>
using namespace std;
const int N = 1005;
const int INF = 99999999;
int graph[N][N];
int n,m,s;
int low[N];
bool vis[N];
bool can[N];
int dijkstra(int s){
    memset(vis,false,sizeof(vis));
    for(int i=1;i<=n;i++){
        low[i] = graph[s][i];
    }
    vis[s] = true;
    for(int i=1;i<n;i++){
        int Min = INF;
        for(int j=1;j<=n;j++){
            if(!vis[j]&&low[j]<Min){
                Min = low[j];
                s= j;
            }
        }
        vis[s] = true;
        for(int j=1;j<=n;j++){
            if(!vis[j]&&low[j]>low[s]+graph[s][j]){
                low[j]=low[s]+graph[s][j];
            }
        }
    }
    int result = INF;
    for(int i=1;i<=n;i++){
        if(can[i])
        result = min(result,low[i]);
    }
    return result;
}
int main()
{
    while(scanf("%d%d%d",&n,&m,&s)!=EOF){
        for(int i=1;i<=n;i++){
            for(int j=1;j<=n;j++){
                if(i==j) graph[i][j] = 0;
                else graph[i][j] = INF;
            }
        }
        for(int i=1;i<=m;i++){
            int a,b,c;
            scanf("%d%d%d",&a,&b,&c);  ///directed ways!!反向添边,因为我们是从终点开始找
            if(graph[b][a]<c) continue;  ///记得判重,不然AC不了
            graph[b][a] = c;
        }
        int t;
        memset(can,false,sizeof(can));
        scanf("%d",&t);
        while(t--){
            int k;
            scanf("%d",&k);
            can[k]=true;
        }
        int c = dijkstra(s);
        if(c>=INF) printf("-1
");
        else printf("%d
",c);
    }
    return 0;
}
原文地址:https://www.cnblogs.com/liyinggang/p/5491026.html